from inspect import getargspec

__all__ = ['autodecorate', 'copy_func', 'getargspec']


def autodecorate(func):
    def autodecorate_wrapped(*args):
        if len(args) > 1:
            return func(*args)
        else:
            arg0 = args[0]
            return lambda *args: func(arg0, *args)
    return autodecorate_wrapped


def copy_func(func):
    import new
    return new.function(func.func_code, func.func_globals, func.func_name, func.func_closure)

